import javax.swing.JOptionPane;

public class Springerproblem {
	public static final int[] nx = { -2, -2, -1, -1, 1, 1, 2, 2 };
	public static final int[] ny = { -1, 1, -2, 2, -2, 2, -1, 1 };
	java.util.Random rand = new java.util.Random();

	public static void main(String[] args) {
		int breite = 0;
		int lnge = 0;
		int ctr = 1;
		int ye = 0;
		int xe = 0;
		int xn, yn;
		lnge = Integer.parseInt(JOptionPane.showInputDialog(null,
				"Geben Sie die Breite eines n*m Schachbretts an : ", "6"));
		breite = Integer.parseInt(JOptionPane.showInputDialog(null,
				"Geben Sie die Lnge eines n*m Schachbretts an : ", "6"));
		xe = Integer.parseInt(JOptionPane.showInputDialog(null,
				"Geben Sie die x-Koordinate des Springers an (zwischen 1 und "
						+ breite + "): ", "2"));
		while (xe > breite)
			xe = Integer.parseInt(JOptionPane.showInputDialog(null,
					"Geben Sie die x-Koordinate des Springers an(zwischen 1 und "
							+ breite + "): ", "2"));
		ye = Integer.parseInt(JOptionPane.showInputDialog(null,
				"Geben Sie die y-Koordinate des Springers an (zwischen 1 und "
						+ lnge + "): ", "2"));
		while (ye > lnge)
			ye = Integer.parseInt(JOptionPane.showInputDialog(null,
					"Geben Sie die y-Koordinate des Springers an (zwischen 1 und "
							+ lnge + "): ", "2"));
		ye--;
		xe--;
		int[][] a = new int[breite][lnge];
		int ursprungX = xe, ursprungY = ye;
		a[ye][xe] = 1;
		int[] xy = new int[2];
		xy[0] = ye;
		xy[1] = xe;
		while (findeBestenWeg(a, breite, lnge, xy)) {
			a[xy[0]][xy[1]] = ++ctr;
		}
		if (ctr == breite * lnge) {
			for (int i = 0; i < breite; i++) {
				System.out.println();
				System.out.println();
				for (int j = 0; j < lnge; j++) {
					System.out.print(a[i][j] + "\t");
				}
			}
			boolean gTour = false;
			for (int i = 0; i < 8; i++) {
				xn = ursprungX + nx[i];
				yn = ursprungY + ny[i];
				if (imSchachbrett(xn, yn, breite, lnge)) {
					if (a[ursprungY + ny[i]][ursprungX + nx[i]] == breite
							* lnge) {
						gTour = true;
					} else
						gTour = false;
				}
			}
			System.out.println();
			System.out.println();
			if (gTour == true)
				System.out.println("Es ist eine geschlossene Springertour!");
			else
				System.out.println("Es ist keine geschlossene Springertour!");
		} else
			System.out
					.println("Es gibt keine Lsung fr diese Startposition!!");
	}

	static boolean imSchachbrett(int x, int y, int breite, int lnge) {
		return ((0 <= x && x < breite) && (0 <= y && y < lnge));
	}

	static int mglicheSchritte(int[][] a, int breite, int lnge, int x, int y) {
		int anzahl = 0;
		int xn, yn;
		for (int i = 0; i < 8; i++) {
			xn = x + nx[i];
			yn = y + ny[i];
			if (imSchachbrett(xn, yn, breite, lnge) && a[xn][yn] == 0)
				anzahl++;
		}
		return anzahl;
	}

	static boolean findeBestenWeg(int[][] a, int breite, int lnge, int[] xy) {
		int temp = Integer.MAX_VALUE;
		int xn, yn, xx = 0, yy = 0;
		java.util.Random rand = new java.util.Random();
		int zufall = 0;
		for (int i = 0; i < 8; i++) {
			xn = xy[0] + nx[i];
			yn = xy[1] + ny[i];
			if (imSchachbrett(xn, yn, breite, lnge) && a[xn][yn] == 0) {
				int schritte = mglicheSchritte(a, breite, lnge, xn, yn);
				if (schritte < temp) {
					temp = schritte;
					xx = xn;
					yy = yn;
				} else
					zufall = rand.nextInt(2);
				schritte = schritte - zufall;
				if (schritte < temp) {
					temp = schritte + zufall;
					xx = xn;
					yy = yn;
				}
			}
		}
		if (temp < Integer.MAX_VALUE) {
			xy[0] = xx;
			xy[1] = yy;
			return true;
		}
		return false;
	}
}
